SDL_blendmode.h File Reference
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_blendmode.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Enumerations

enum | SDL_BlendMode { SDL_BLENDMODE_NONE = 0x00000000 , SDL_BLENDMODE_BLEND = 0x00000001 , SDL_BLENDMODE_ADD = 0x00000002 , SDL_BLENDMODE_MOD = 0x00000004 , SDL_BLENDMODE_MUL = 0x00000008 , SDL_BLENDMODE_INVALID = 0x7FFFFFFF }
enum | SDL_BlendOperation { SDL_BLENDOPERATION_ADD = 0x1 , SDL_BLENDOPERATION_SUBTRACT = 0x2 , SDL_BLENDOPERATION_REV_SUBTRACT = 0x3 , SDL_BLENDOPERATION_MINIMUM = 0x4 , SDL_BLENDOPERATION_MAXIMUM = 0x5 }
enum | SDL_BlendFactor { SDL_BLENDFACTOR_ZERO = 0x1 , SDL_BLENDFACTOR_ONE = 0x2 , SDL_BLENDFACTOR_SRC_COLOR = 0x3 , SDL_BLENDFACTOR_ONE_MINUS_SRC_COLOR = 0x4 , SDL_BLENDFACTOR_SRC_ALPHA = 0x5 , SDL_BLENDFACTOR_ONE_MINUS_SRC_ALPHA = 0x6 , SDL_BLENDFACTOR_DST_COLOR = 0x7 , SDL_BLENDFACTOR_ONE_MINUS_DST_COLOR = 0x8 , SDL_BLENDFACTOR_DST_ALPHA = 0x9 , SDL_BLENDFACTOR_ONE_MINUS_DST_ALPHA = 0xA }

## Functions

SDL_BlendMode | SDL_ComposeCustomBlendMode (SDL_BlendFactor srcColorFactor, SDL_BlendFactor dstColorFactor, SDL_BlendOperation colorOperation, SDL_BlendFactor srcAlphaFactor, SDL_BlendFactor dstAlphaFactor, SDL_BlendOperation alphaOperation)

## Enumeration Type Documentation

## SDL_BlendFactor

enum SDL_BlendFactor

The normalized factor used to multiply pixel components

Enumerator
SDL_BLENDFACTOR_ZERO | 0, 0, 0, 0
SDL_BLENDFACTOR_ONE | 1, 1, 1, 1
SDL_BLENDFACTOR_SRC_COLOR | srcR, srcG, srcB, srcA
SDL_BLENDFACTOR_ONE_MINUS_SRC_COLOR | 1-srcR, 1-srcG, 1-srcB, 1-srcA
SDL_BLENDFACTOR_SRC_ALPHA | srcA, srcA, srcA, srcA
SDL_BLENDFACTOR_ONE_MINUS_SRC_ALPHA | 1-srcA, 1-srcA, 1-srcA, 1-srcA
SDL_BLENDFACTOR_DST_COLOR | dstR, dstG, dstB, dstA
SDL_BLENDFACTOR_ONE_MINUS_DST_COLOR | 1-dstR, 1-dstG, 1-dstB, 1-dstA
SDL_BLENDFACTOR_DST_ALPHA | dstA, dstA, dstA, dstA
SDL_BLENDFACTOR_ONE_MINUS_DST_ALPHA | 1-dstA, 1-dstA, 1-dstA, 1-dstA

Definition at line 78 of file SDL_blendmode.h.

{
SDL_BLENDFACTOR_ZERO = 0x1, /**< 0, 0, 0, 0 */
SDL_BLENDFACTOR_ONE = 0x2, /**< 1, 1, 1, 1 */
SDL_BLENDFACTOR_SRC_COLOR = 0x3, /**< srcR, srcG, srcB, srcA */
SDL_BLENDFACTOR_ONE_MINUS_SRC_COLOR = 0x4, /**< 1-srcR, 1-srcG, 1-srcB, 1-srcA */
SDL_BLENDFACTOR_SRC_ALPHA = 0x5, /**< srcA, srcA, srcA, srcA */
SDL_BLENDFACTOR_ONE_MINUS_SRC_ALPHA = 0x6, /**< 1-srcA, 1-srcA, 1-srcA, 1-srcA */
SDL_BLENDFACTOR_DST_COLOR = 0x7, /**< dstR, dstG, dstB, dstA */
SDL_BLENDFACTOR_ONE_MINUS_DST_COLOR = 0x8, /**< 1-dstR, 1-dstG, 1-dstB, 1-dstA */
SDL_BLENDFACTOR_DST_ALPHA = 0x9, /**< dstA, dstA, dstA, dstA */
SDL_BLENDFACTOR_ONE_MINUS_DST_ALPHA = 0xA /**< 1-dstA, 1-dstA, 1-dstA, 1-dstA */
} SDL_BlendFactor;
SDL_BlendFactor
SDL_BlendFactor
Definition SDL_blendmode.h:79
SDL_BLENDFACTOR_ONE_MINUS_SRC_COLOR
@ SDL_BLENDFACTOR_ONE_MINUS_SRC_COLOR
Definition SDL_blendmode.h:83
SDL_BLENDFACTOR_ZERO
@ SDL_BLENDFACTOR_ZERO
Definition SDL_blendmode.h:80
SDL_BLENDFACTOR_SRC_COLOR
@ SDL_BLENDFACTOR_SRC_COLOR
Definition SDL_blendmode.h:82
SDL_BLENDFACTOR_SRC_ALPHA
@ SDL_BLENDFACTOR_SRC_ALPHA
Definition SDL_blendmode.h:84
SDL_BLENDFACTOR_ONE_MINUS_DST_COLOR
@ SDL_BLENDFACTOR_ONE_MINUS_DST_COLOR
Definition SDL_blendmode.h:87
SDL_BLENDFACTOR_ONE_MINUS_DST_ALPHA
@ SDL_BLENDFACTOR_ONE_MINUS_DST_ALPHA
Definition SDL_blendmode.h:89
SDL_BLENDFACTOR_ONE_MINUS_SRC_ALPHA
@ SDL_BLENDFACTOR_ONE_MINUS_SRC_ALPHA
Definition SDL_blendmode.h:85
SDL_BLENDFACTOR_DST_ALPHA
@ SDL_BLENDFACTOR_DST_ALPHA
Definition SDL_blendmode.h:88
SDL_BLENDFACTOR_DST_COLOR
@ SDL_BLENDFACTOR_DST_COLOR
Definition SDL_blendmode.h:86
SDL_BLENDFACTOR_ONE
@ SDL_BLENDFACTOR_ONE
Definition SDL_blendmode.h:81

## SDL_BlendMode

enum SDL_BlendMode

# CategoryBlendmode

Header file declaring the SDL_BlendMode enumeration The blend mode used in SDL_RenderCopy() and drawing operations.

Enumerator
SDL_BLENDMODE_NONE | no blending dstRGBA = srcRGBA
SDL_BLENDMODE_BLEND | alpha blending dstRGB = (srcRGB * srcA) + (dstRGB * (1-srcA)) dstA = srcA + (dstA * (1-srcA))
SDL_BLENDMODE_ADD | additive blending dstRGB = (srcRGB * srcA) + dstRGB dstA = dstA
SDL_BLENDMODE_MOD | color modulate dstRGB = srcRGB * dstRGB dstA = dstA
SDL_BLENDMODE_MUL | color multiply dstRGB = (srcRGB * dstRGB) + (dstRGB * (1-srcA)) dstA = dstA
SDL_BLENDMODE_INVALID |

Definition at line 40 of file SDL_blendmode.h.

{
SDL_BLENDMODE_NONE = 0x00000000, /**< no blending
dstRGBA = srcRGBA */
SDL_BLENDMODE_BLEND = 0x00000001, /**< alpha blending
dstRGB = (srcRGB * srcA) + (dstRGB * (1-srcA))
dstA = srcA + (dstA * (1-srcA)) */
SDL_BLENDMODE_ADD = 0x00000002, /**< additive blending
dstRGB = (srcRGB * srcA) + dstRGB
dstA = dstA */
SDL_BLENDMODE_MOD = 0x00000004, /**< color modulate
dstRGB = srcRGB * dstRGB
dstA = dstA */
SDL_BLENDMODE_MUL = 0x00000008, /**< color multiply
dstRGB = (srcRGB * dstRGB) + (dstRGB * (1-srcA))
dstA = dstA */
SDL_BLENDMODE_INVALID = 0x7FFFFFFF
/* Additional custom blend modes can be returned by SDL_ComposeCustomBlendMode() */
} SDL_BlendMode;
SDL_BlendMode
SDL_BlendMode
Definition SDL_blendmode.h:41
SDL_BLENDMODE_NONE
@ SDL_BLENDMODE_NONE
Definition SDL_blendmode.h:42
SDL_BLENDMODE_ADD
@ SDL_BLENDMODE_ADD
Definition SDL_blendmode.h:47
SDL_BLENDMODE_BLEND
@ SDL_BLENDMODE_BLEND
Definition SDL_blendmode.h:44
SDL_BLENDMODE_INVALID
@ SDL_BLENDMODE_INVALID
Definition SDL_blendmode.h:56
SDL_BLENDMODE_MUL
@ SDL_BLENDMODE_MUL
Definition SDL_blendmode.h:53
SDL_BLENDMODE_MOD
@ SDL_BLENDMODE_MOD
Definition SDL_blendmode.h:50

## SDL_BlendOperation

enum SDL_BlendOperation

The blend operation used when combining source and destination pixel components

Enumerator
SDL_BLENDOPERATION_ADD | dst + src: supported by all renderers
SDL_BLENDOPERATION_SUBTRACT | src - dst : supported by D3D9, D3D11, OpenGL, OpenGLES
SDL_BLENDOPERATION_REV_SUBTRACT | dst - src : supported by D3D9, D3D11, OpenGL, OpenGLES
SDL_BLENDOPERATION_MINIMUM | min(dst, src) : supported by D3D9, D3D11
SDL_BLENDOPERATION_MAXIMUM | max(dst, src) : supported by D3D9, D3D11

Definition at line 66 of file SDL_blendmode.h.

{
SDL_BLENDOPERATION_ADD = 0x1, /**< dst + src: supported by all renderers */
SDL_BLENDOPERATION_SUBTRACT = 0x2, /**< src - dst : supported by D3D9, D3D11, OpenGL, OpenGLES */
SDL_BLENDOPERATION_REV_SUBTRACT = 0x3, /**< dst - src : supported by D3D9, D3D11, OpenGL, OpenGLES */
SDL_BLENDOPERATION_MINIMUM = 0x4, /**< min(dst, src) : supported by D3D9, D3D11 */
SDL_BLENDOPERATION_MAXIMUM = 0x5 /**< max(dst, src) : supported by D3D9, D3D11 */
} SDL_BlendOperation;
SDL_BlendOperation
SDL_BlendOperation
Definition SDL_blendmode.h:67
SDL_BLENDOPERATION_MAXIMUM
@ SDL_BLENDOPERATION_MAXIMUM
Definition SDL_blendmode.h:72
SDL_BLENDOPERATION_MINIMUM
@ SDL_BLENDOPERATION_MINIMUM
Definition SDL_blendmode.h:71
SDL_BLENDOPERATION_REV_SUBTRACT
@ SDL_BLENDOPERATION_REV_SUBTRACT
Definition SDL_blendmode.h:70
SDL_BLENDOPERATION_ADD
@ SDL_BLENDOPERATION_ADD
Definition SDL_blendmode.h:68
SDL_BLENDOPERATION_SUBTRACT
@ SDL_BLENDOPERATION_SUBTRACT
Definition SDL_blendmode.h:69

## Function Documentation

## SDL_ComposeCustomBlendMode()

SDL_BlendMode SDL_ComposeCustomBlendMode | ( | SDL_BlendFactor | srcColorFactor,
|  | SDL_BlendFactor | dstColorFactor,
|  | SDL_BlendOperation | colorOperation,
|  | SDL_BlendFactor | srcAlphaFactor,
|  | SDL_BlendFactor | dstAlphaFactor,
|  | SDL_BlendOperation | alphaOperation )

extern

Compose a custom blend mode for renderers.

The functions SDL_SetRenderDrawBlendMode and SDL_SetTextureBlendMode accept the SDL_BlendMode returned by this function if the renderer supports it.

A blend mode controls how the pixels from a drawing operation (source) get combined with the pixels from the render target (destination). First, the components of the source and destination pixels get multiplied with their blend factors. Then, the blend operation takes the two products and calculates the result that will get stored in the render target.

Expressed in pseudocode, it would look like this:

dstRGB = colorOperation(srcRGB * srcColorFactor, dstRGB * dstColorFactor);
dstA = alphaOperation(srcA * srcAlphaFactor, dstA * dstAlphaFactor);

Where the functions colorOperation(src, dst) and alphaOperation(src, dst) can return one of the following:

- src + dst
- src - dst
- dst - src
- min(src, dst)
- max(src, dst)

The red, green, and blue components are always multiplied with the first, second, and third components of the SDL_BlendFactor, respectively. The fourth component is not used.

The alpha component is always multiplied with the fourth component of the SDL_BlendFactor. The other components are not used in the alpha calculation.

Support for these blend modes varies for each renderer. To check if a specific SDL_BlendMode is supported, create a renderer and pass it to either SDL_SetRenderDrawBlendMode or SDL_SetTextureBlendMode. They will return with an error if the blend mode is not supported.

This list describes the support of custom blend modes for each renderer in SDL 2.0.6. All renderers support the four blend modes listed in the SDL_BlendMode enumeration.

- direct3d: Supports all operations with all factors. However, some factors produce unexpected results with SDL_BLENDOPERATION_MINIMUM and SDL_BLENDOPERATION_MAXIMUM.
- direct3d11: Same as Direct3D 9.
- opengl: Supports the SDL_BLENDOPERATION_ADD operation with all factors. OpenGL versions 1.1, 1.2, and 1.3 do not work correctly with SDL 2.0.6.
- opengles: Supports the SDL_BLENDOPERATION_ADD operation with all factors. Color and alpha factors need to be the same. OpenGL ES 1 implementation specific: May also support SDL_BLENDOPERATION_SUBTRACT and SDL_BLENDOPERATION_REV_SUBTRACT. May support color and alpha operations being different from each other. May support color and alpha factors being different from each other.
- opengles2: Supports the SDL_BLENDOPERATION_ADD, SDL_BLENDOPERATION_SUBTRACT, SDL_BLENDOPERATION_REV_SUBTRACT operations with all factors.
- psp: No custom blend mode support.
- software: No custom blend mode support.

Some renderers do not provide an alpha component for the default render target. The SDL_BLENDFACTOR_DST_ALPHA and SDL_BLENDFACTOR_ONE_MINUS_DST_ALPHA factors do not have an effect in this case.

Parameters

  srcColorFactor | the SDL_BlendFactor applied to the red, green, and blue components of the source pixels.
  dstColorFactor | the SDL_BlendFactor applied to the red, green, and blue components of the destination pixels.
  colorOperation | the SDL_BlendOperation used to combine the red, green, and blue components of the source and destination pixels.
  srcAlphaFactor | the SDL_BlendFactor applied to the alpha component of the source pixels.
  dstAlphaFactor | the SDL_BlendFactor applied to the alpha component of the destination pixels.
  alphaOperation | the SDL_BlendOperation used to combine the alpha component of the source and destination pixels.

Returns
  an SDL_BlendMode that represents the chosen factors and operations.

Since
  This function is available since SDL 2.0.6.

See also
  SDL_SetRenderDrawBlendMode
  SDL_GetRenderDrawBlendMode
  SDL_SetTextureBlendMode
  SDL_GetTextureBlendMode